from flask import Flask
from flask_socketio import SocketIO, emit
from flask_cors import CORS
import jsonify
from flask import render_template
from RPLCD import CharLCD
from RPi import GPIO
from Database import Database
from pyfirmata import Arduino, util
from nanpy import ArduinoApi, SerialManager
import threading
from datetime import *

# import random
import signal
import os

# import threading
import sys
import time
from time import sleep
import subprocess
import mysql.connector

import socket
import os

endpoint = '/api/v1'
app = Flask(__name__)
CORS(app)
socketio = SocketIO(app)
conn = Database(app, "mct", "mct", "smartaquariumdb")


# def controleLamp():
#     while True:
#         print("Controleren lamp")
#         # 1 controleer wat de gebruiker wenst: wenst hij dat de lamp tussen twee uren aanstaat
#
#         # 2 indien ja: controleer uur: is het uur tussen 14u en 15u?
#         #       2a: eventueel hier lamp aansteken
#         #       2b: niets doen
#
#         # even in slaap leggen, en opnieuw controleren
#         time.sleep(1000)
#
#
# print("Dit is het mainprogramma")
# # eventueel kan de gebruiker via de frontend de controlelamp aanzetten
# # ...
# print("hier gaat het main-programma halen")
#
# # start controle lamp -> bij opstart van applicatie op de pi
# th = threading.Thread(target=controleLamp)
# th.start()


print("Lamp")
lamp = 8
druksensor = 0
lampstate = False

try:
    connection = SerialManager()
    a = ArduinoApi(connection=connection)
except:
    print("Connection to arduino failed")

    a.pinMode(lamp, a.OUTPUT)
    a.pinMode(druksensor, a.INPUT)


# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# Routes
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------

@app.route("/")
def init():
    return render_template("sites/index.html")
    get_temperature()


@app.route("/Configurations.html")
def configurationshtml():
    return render_template("sites/Configurations.html")


@app.route("/index.html")
def indexhtml():
    return render_template("sites/index.html")


@app.route("/GraphPH.html")
def phhtml():
    return render_template("sites/GraphPH.html")


@app.route("/GraphTemp.html")
def temphtml():
    return render_template("sites/GraphTemp.html")


@app.route('/api/v1/')
def get_data():
    pass


@socketio.on("connect")
def connectie():
    print("Client connected to the socket")


@socketio.on('tempData')
def tempValues(data):
    print("ik zit in tempData")
    data = conn.get_data(
        "SELECT convert(time(MeetDatum),char) as 'time',round(Waarde,1) as 'temp' FROM smartaquariumdb.meting WHERE Sensor_ID = 1 order by MeetDatum desc limit 10;")
    print(data)
    socketio.emit("tempData", data)


@socketio.on('phData')
def phValues(dataph):
    print("ik zit in phData")
    dataph = conn.get_data(
        "SELECT convert(time(MeetDatum),char) as 'time',round(Waarde,1) as 'ph' FROM smartaquariumdb.meting WHERE Sensor_ID = 2 order by MeetDatum desc limit 10;")
    print(dataph)
    socketio.emit("phData", dataph)


@socketio.on('light')
def light(parameter):
    global druksensor
    global lampstate
    global lamp
    global a

    print("testje")

    state = conn.get_data('SELECT State FROM Licht')
    print(state)

    if state[0]["State"] == 0:
        conn.set_data('UPDATE Licht set State = 1')
        a.digitalWrite(lamp, a.HIGH)
        socketio.emit('button', True)

    else:
        conn.set_data('UPDATE Licht set State = 0')
        a.digitalWrite(lamp, a.LOW)
        socketio.emit('button', False)


# Added
knop1_value = False


@socketio.on("connect")
def connecting():
    socketio.emit("connected", {'value': knop1_value})
    print("Connection with client established")


# Tot hier


# @app.route(endpoint + '/emit')
# def emittest():
#     get_temperature(5)
#
# @socketio.on("init")
# def init():
#     print("init")
#     get_temperature(5)

# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# Routes
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------

# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# Data in database
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
def insert_meting(gemeten_sensor, gemeten_waarde):
    try:
        connection = mysql.connector.connect(host='localhost',
                                             database='smartaquariumdb',
                                             user='mct',
                                             password='mct')
        sql_insert_query = """ INSERT INTO smartaquariumdb.meting
                          (`Sensor_ID`,`Waarde`) VALUES (%s,%s)"""
        insert_tuple = (gemeten_sensor, gemeten_waarde)
        cursor = connection.cursor()
        result = cursor.execute(sql_insert_query, insert_tuple)
        connection.commit()
        print("Record inserted successfully into database smartaquariumdb table meting")
    except mysql.connector.Error as error:
        connection.rollback()
        print("Failed inserting record into database smartaquariumdb table meting {}".format(error))
        # print("Failed inserting record into python_users table {}".format(error))
    finally:
        if (connection.is_connected()):
            cursor.close()
            connection.close()


# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# data in database
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------


# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# lamp + druksensor
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
class myThreadLamp(threading.Thread):
    def __init__(self, threadID, name, intervalseclamp):
        threading.Thread.__init__(self)
        self.threadID = threadID
        self.name = name
        self.intervalseclamp = intervalseclamp

    def run(self):
        print("Starting " + self.name)
        controle_lamp(self.intervalseclamp)
        print("Exiting " + self.name)


def controle_lamp(intervallamp):
    print("Lamp")
    lamp = 8
    druksensor = 0
    lampstate = False

    try:
        connection = SerialManager()
        a = ArduinoApi(connection=connection)
    except:
        print("Connection to arduino failed")

    a.pinMode(lamp, a.OUTPUT)
    a.pinMode(druksensor, a.INPUT)

    while True:
        # print("Lamp2")
        fsrreading = a.analogRead(druksensor)
        # print(fsrreading)
        if fsrreading > 10:
            if lampstate:
                a.digitalWrite(lamp, a.LOW)
                lampstate = False
                print("turned off light")
                socketio.emit("toggle", {'value': False})
            else:
                a.digitalWrite(lamp, a.HIGH)
                lampstate = True
                print("turned on light")
                socketio.emit("toggle", {'value': True})

        # print("sleep")
        sleep(intervallamp)







# class myThreadLamp(threading.Thread):
#     def __init__(self, threadID, name, intervalseclamp):
#         threading.Thread.__init__(self)
#         self.threadID = threadID
#         self.name = name
#         self.intervalseclamp = intervalseclamp
#
#     def run(self):
#         print("Starting " + self.name)
#         controle_lamp(self.intervalseclamp)
#         print("Exiting " + self.name)
#
#
# def controle_lamp(intervallamp):
#     global druksensor
#     global lampstate
#     global lamp
#     global a
#
#     while True:
#         # print("Lamp2")
#         fsrreading = a.analogRead(druksensor)
#         # print(fsrreading)
#         if fsrreading > 10:
#             if lampstate:
#                 a.digitalWrite(lamp, a.LOW)
#                 lampstate = False
#                 print("turned off light")
#                 socketio.emit("toggle", {'value': False})
#             else:
#                 a.digitalWrite(lamp, a.HIGH)
#                 lampstate = True
#                 print("turned on light")
#                 socketio.emit("toggle", {'value': True})
#
#         # print("sleep")
#         sleep(intervallamp)


# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# lamp + druksensor
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------


# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# PH sensor
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
class myThreadPH(threading.Thread):
    def __init__(self, threadID, name, intervalsecph, intervalinsertdbph):
        threading.Thread.__init__(self)
        self.threadID = threadID
        self.name = name
        self.intervalsecph = intervalsecph
        self.intervalinsertdbph = intervalinsertdbph

    def run(self):
        print("Starting " + self.name)
        controle_ph(self.intervalsecph, self.intervalinsertdbph)
        print("Exiting " + self.name)


def controle_ph(intervalph, intervaldbph):
    global currentPH
    print("PH")
    ph = 1
    nrofmeasuresbeforeinsertph = int(intervaldbph / intervalph)
    print(nrofmeasuresbeforeinsertph)
    counterdbph = 0
    # druksensor = 0

    try:
        connection = SerialManager()
        a = ArduinoApi(connection=connection)
    except:
        print("Connection to arduino failed")

    a.pinMode(ph, a.INPUT)
    # a.pinMode(druksensor, a.INPUT)

    while True:
        phreading = a.analogRead(ph)
        phvoltage = phreading * 5 / 1023
        phwaarde = (phvoltage * 7) / 2.5
        # print("\t \t \t \t \t \tPHsensor reading", "=", phreading, ".")
        # print("\t \t \t \t \t \tPHsensor voltage", "=", phvoltage, ".")
        # print("\t \t \t \t \t \tPHsensor ph waarde", "=", phwaarde, ".")
        print("\t \t \t \t \t \tPHsensor ph waarde", "=", round(phwaarde, 2), ".")
        socketio.emit("phwaarde", round(phwaarde, 2))
        currentPH = round(phwaarde, 2)
        if counterdbph == nrofmeasuresbeforeinsertph:
            insert_meting(2, phwaarde)
            counterdbph = 0
        else:
            counterdbph += 1
            time.sleep(intervalph)


# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# PH sensor
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------


# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# Temperatuursensor
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
class myThreadTemp(threading.Thread):
    def __init__(self, threadID, name, intervalsectemp, intervaldbinsert):
        threading.Thread.__init__(self)
        self.threadID = threadID
        self.name = name
        self.intervalsectemp = intervalsectemp
        self.intervaldbinsert = intervaldbinsert

    def run(self):
        print("Starting " + self.name)
        get_temperature(self.intervalsectemp, self.intervaldbinsert)
        print("Exiting " + self.name)


def get_temperature(intervalmsr, intervaldb):
    print("checkingtemp")
    global currentTemperature
    currentTemperature = 25
    temp = {}
    sensorids = ["28-02049245cd9c"]
    nrofmeasuresbeforeinsert = int(intervaldb / intervalmsr)
    print(nrofmeasuresbeforeinsert)
    counterdb = 0
    while True:
        for sensor in range(len(sensorids)):
            try:
                tfile = open("/sys/bus/w1/devices/" + sensorids[sensor] + "/w1_slave")
                text = tfile.read()
                tfile.close()
                secondline = text.split("\n")[1]
                temperaturedata = secondline.split(" ")[9]
                print(temperaturedata)
                temperature = float(temperaturedata[2:])
                temp[sensor] = temperature / 1000
                print("\t \t \t \t \t \tTemperatuursensor", sensor, "=", temp[sensor], "°C.")
                socketio.emit("waal", temp[sensor])
                if counterdb == nrofmeasuresbeforeinsert:
                    insert_meting(1, temp[sensor])
                    counterdb = 0
                else:
                    counterdb += 1
                time.sleep(intervalmsr)
                currentTemperature = temp[sensor]
            except Exception as x:
                pass


# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# Temperatuursensor
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------


# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# LCD
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# Wiring LCD
# ----------
# VSS pin                            - negative rail
# VVD pin                            - positive
# VO                                 - middle pin potentiometer (contrast)
# RS                                 - GPIO26 -> 37
# RW                                 - negative rail
# E                                  - GPIO19 -> 35
# D0-3                               - not wired (is for 8 bits)
# D4                                 - GPIO20 -> 38
# D5                                 - GPIO16 -> 36
# D6                                 - GPIO12 -> 32
# D7                                 - GPIO22 -> 15
# A                                  - middle pin potentiometer (backlight)
# K                                  - negative rail
# outer pin contrast potentiometer   - negative rail
# outer pin backlight potentiometer  - positive rail
# 5volt pi                           - positive rail
# gnd pi                             - negative rail


class myThreadUpdateLCD(threading.Thread):
    def __init__(self, threadID, name, intervalsecLCD):
        threading.Thread.__init__(self)
        self.threadID = threadID
        self.name = name
        self.intervalsecLCD = intervalsecLCD

    def run(self):
        print("Starting " + self.name)
        write2lcd(self.intervalsecLCD)
        print("Exiting " + self.name)


def write2lcd(intervalLCD):
    lcd = CharLCD(numbering_mode=GPIO.BOARD, cols=16, rows=2, pin_rs=37, pin_e=35, pins_data=[38, 36, 32, 15])
    time.sleep(30)
    while True:
        print("Updating LCD")
        lcd.clear()
        round_graden = round(currentTemperature, 1)
        round_ph = round(currentPH, 1)
        # MyIP = subprocess.getoutput("hostname -I")
        gw = os.popen("ip -4 route show default").read().split()
        s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        s.connect((gw[2], 0))
        ipaddr = s.getsockname()[0]
        line1 = str(round_graden) + " " + chr(223) + "C" + "     PH:" + str(round_ph)
        line2 = ipaddr
        print(line1)
        print(line2)
        lcd.write_string(line1)
        lcd.cursor_pos = (1, 0)
        lcd.write_string(line2)
        time.sleep(intervalLCD)


# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# LCD
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------

# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# FeedFish (stapper motor)
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# Wiring stepmotor 28BYJ-48
# -------------------------
# IN1 - GPIO23 -> 16
# IN2 - GPIO24 -> 18
# IN3 - GPIO25 -> 22
# IN4 - GPIO21 -> 40

# def FeedFish(NrOfCompartiments):
#     GPIO.setmode(GPIO.BOARD)
#
#     # Define pins
#     P_A1 = 16
#     P_A2 = 18
#     P_B1 = 22
#     P_B2 = 40
#
#     FullTurn_NumberOfSteps = 512
#     Compartiment_NumberOfSteps = FullTurn_NumberOfSteps / NrOfCompartiments
#
#     GPIO.setup(P_A1, GPIO.OUT)
#     GPIO.setup(P_A2, GPIO.OUT)
#     GPIO.setup(P_B1, GPIO.OUT)
#     GPIO.setup(P_B2, GPIO.OUT)
#
#     def forwardStep():
#         setStepper(1, 0, 1, 0)
#         setStepper(0, 1, 1, 0)
#         setStepper(0, 1, 0, 1)
#         setStepper(1, 0, 0, 1)
#
#     def setStepper(in1, in2, in3, in4):
#         GPIO.output(P_A1, in1)
#         GPIO.output(P_A2, in2)
#         GPIO.output(P_B1, in3)
#         GPIO.output(P_B2, in4)
#         time.sleep(0.05)
#
#     for i in range(int(Compartiment_NumberOfSteps)):
#         forwardStep()


class myThreadFeeder(threading.Thread):
    def __init__(self, threadID, name, foodtime):
        threading.Thread.__init__(self)
        self.threadID = threadID
        self.name = name
        self.foodtime = foodtime

    def run(self):
        print("Starting " + self.name)
        check_fishfeeding(self.foodtime)
        print("Exiting " + self.name)


def check_fishfeeding(feedingtime):
    GPIO.setmode(GPIO.BOARD)

    # Define pins
    P_A1 = 16
    P_A2 = 18
    P_B1 = 22
    P_B2 = 40

    NrOfCompartiments = 6
    FullTurn_NumberOfSteps = 512
    Compartiment_NumberOfSteps = FullTurn_NumberOfSteps / NrOfCompartiments

    GPIO.setup(P_A1, GPIO.OUT)
    GPIO.setup(P_A2, GPIO.OUT)
    GPIO.setup(P_B1, GPIO.OUT)
    GPIO.setup(P_B2, GPIO.OUT)

    def forwardStep():
        setStepper(1, 0, 1, 0)
        setStepper(0, 1, 1, 0)
        setStepper(0, 1, 0, 1)
        setStepper(1, 0, 0, 1)

    def setStepper(in1, in2, in3, in4):
        GPIO.output(P_A1, in1)
        GPIO.output(P_A2, in2)
        GPIO.output(P_B1, in3)
        GPIO.output(P_B2, in4)
        time.sleep(0.05)

    while True:
        print("I'm checking if it is time to feed the fish now")
        now = datetime.now()
        CurrentHM = now.strftime("%H:%M")
        print("Current Time: " + CurrentHM)

        if CurrentHM == feedingtime:
            for i in range(int(Compartiment_NumberOfSteps)):
                print("Feeding now")
                forwardStep()
        else:
            print("No feeding time yet")
        time.sleep(60)


# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------
# FeedFish (Stepper motor)
# ----------------------------------------------------------------------------------------------------------------------
# ----------------------------------------------------------------------------------------------------------------------


if __name__ == '__main__':
    thread1 = myThreadTemp(1, "CheckTemperature", 1, 60)
    thread2 = myThreadLamp(2, "CheckLamp", 1)
    thread3 = myThreadPH(3, "ph", 15, 60)
    thread4 = myThreadFeeder(4, "CheckFood", "04:04")
    thread5 = myThreadUpdateLCD(5, "UpdateLCD", 30)

    thread1.start()
    thread2.start()
    thread3.start()
    thread4.start()
    thread5.start()

if __name__ == '__main__':
    # socketio.run(app, host="127.0.0.1", port=5000)
    socketio.run(app, host="0.0.0.0", port=5000)
