socket.on('tempData', function(data) {
  console.log('received:');
  console.log(data);
  loadGraph(data);
});

const loadGraph = function(datasets) {
  console.log('received in loadGraph');
  const labels = [];
  const data = [];
  for (let dataset of datasets) {
    labels.push(dataset['time']);
    data.push(dataset['temp']);
  }
  var ctx = document.getElementById('myChart').getContext('2d');
  var myChart = new Chart(ctx, {
    type: 'line',
    data: {
      labels: labels,
      datasets: [
        {
          label: 'Time',
          data: data,
          backgroundColor: ['transparent'],
          borderColor: '#000',
          pointBackgroundColor: 'white'
        }
      ]
    }
  });
};

const init = function() {
  socket.emit('tempData', true);
};
document.addEventListener('DOMContentLoaded', init);

/*
let linechart = new Chart(CHART, {
  type: 'line',
  data: (data = {
    labels: ['t1', 't2', 't3'],
    datasets: [
      {
        label: LabelName,
        fill: true,
        lineTension: 0.1,
        backgroundColor: '#',
        borderColor: '#000',
        borderDash: [],
        borderDashOffset: 0.0,
        borderJoinStyle: 'mitter',
        pointBorderColor: '#000',
        pointBackgroundColor: '#fff',
        pointBorderWidth: 1,
        pointBorderRadius: 5,
        pointHoverBackgroundColor: '#fff',
        pointHoverBorderColor: '#fff',
        pointHoverBorderWidth: 2,
        pointRadius: 1,
        pointHitRadius: 10,
        data: [20, 22, 25, 20, 18, 29, 32]
      }
    ]
  })
});
*/
